---
# Cop supports --auto-correct.
RSpec/ReturnFromStub:
  # Offense count: 703
  # Temporarily disabled due to too many offenses
  Enabled: false
  Exclude:
    - 'ee/spec/controllers/admin/geo/nodes_controller_spec.rb'
    - 'ee/spec/controllers/groups/billings_controller_spec.rb'
    - 'ee/spec/controllers/groups/group_members_controller_spec.rb'
    - 'ee/spec/controllers/profiles/billings_controller_spec.rb'
    - 'ee/spec/controllers/projects/branches_controller_spec.rb'
    - 'ee/spec/features/account_recovery_regular_check_spec.rb'
    - 'ee/spec/features/admin/groups/admin_changes_plan_spec.rb'
    - 'ee/spec/features/burndown_charts_spec.rb'
    - 'ee/spec/features/groups/group_settings_spec.rb'
    - 'ee/spec/features/merge_trains/two_merge_requests_on_train_spec.rb'
    - 'ee/spec/features/projects/integrations/user_activates_jira_spec.rb'
    - 'ee/spec/features/projects/milestones/milestone_spec.rb'
    - 'ee/spec/features/projects/new_project_spec.rb'
    - 'ee/spec/features/projects/pipelines/pipeline_spec.rb'
    - 'ee/spec/features/projects/settings/ee/service_desk_setting_spec.rb'
    - 'ee/spec/features/promotion_spec.rb'
    - 'ee/spec/features/refactor_blob_viewer_disabled/projects/path_locks_spec.rb'
    - 'ee/spec/features/trials/select_namespace_spec.rb'
    - 'ee/spec/graphql/mutations/projects/set_locked_spec.rb'
    - 'ee/spec/helpers/application_helper_spec.rb'
    - 'ee/spec/helpers/ee/auth_helper_spec.rb'
    - 'ee/spec/helpers/ee/ci/pipelines_helper_spec.rb'
    - 'ee/spec/helpers/ee/groups_helper_spec.rb'
    - 'ee/spec/helpers/ee/issues_helper_spec.rb'
    - 'ee/spec/helpers/ee/lock_helper_spec.rb'
    - 'ee/spec/helpers/ee/operations_helper_spec.rb'
    - 'ee/spec/helpers/ee/security_orchestration_helper_spec.rb'
    - 'ee/spec/helpers/nav/new_dropdown_helper_spec.rb'
    - 'ee/spec/helpers/nav/top_nav_helper_spec.rb'
    - 'ee/spec/helpers/preferences_helper_spec.rb'
    - 'ee/spec/lib/banzai/filter/cross_project_issuable_information_filter_spec.rb'
    - 'ee/spec/lib/banzai/filter/issuable_reference_expansion_filter_spec.rb'
    - 'ee/spec/lib/ee/feature_spec.rb'
    - 'ee/spec/lib/ee/gitlab/checks/push_rules/branch_check_spec.rb'
    - 'ee/spec/lib/ee/gitlab/database_spec.rb'
    - 'ee/spec/lib/gitlab/ci/minutes/build_consumption_spec.rb'
    - 'ee/spec/lib/gitlab/ci/minutes/cost_factor_spec.rb'
    - 'ee/spec/lib/gitlab/code_owners_spec.rb'
    - 'ee/spec/lib/gitlab/geo/health_check_spec.rb'
    - 'ee/spec/lib/gitlab/geo/logger_spec.rb'
    - 'ee/spec/lib/gitlab/geo/replication/base_transfer_spec.rb'
    - 'ee/spec/lib/gitlab/geo/replication/file_transfer_spec.rb'
    - 'ee/spec/lib/gitlab/geo_spec.rb'
    - 'ee/spec/lib/gitlab/git_access_spec.rb'
    - 'ee/spec/lib/gitlab/git_access_wiki_spec.rb'
    - 'ee/spec/lib/omni_auth/strategies/group_saml_spec.rb'
    - 'ee/spec/lib/system_check/geo/authorized_keys_check_spec.rb'
    - 'ee/spec/lib/system_check/geo/http_connection_check_spec.rb'
    - 'ee/spec/models/ci/build_spec.rb'
    - 'ee/spec/models/concerns/ee/project_security_scanners_information_spec.rb'
    - 'ee/spec/models/ee/namespace_spec.rb'
    - 'ee/spec/models/ee/user_spec.rb'
    - 'ee/spec/models/license_spec.rb'
    - 'ee/spec/models/merge_request/blocking_spec.rb'
    - 'ee/spec/models/project_spec.rb'
    - 'ee/spec/models/vulnerabilities/finding_spec.rb'
    - 'ee/spec/policies/project_policy_spec.rb'
    - 'ee/spec/presenters/ci/build_presenter_spec.rb'
    - 'ee/spec/presenters/merge_request_presenter_spec.rb'
    - 'ee/spec/requests/admin/credentials_controller_spec.rb'
    - 'ee/spec/services/auto_merge/add_to_merge_train_when_pipeline_succeeds_service_spec.rb'
    - 'ee/spec/services/auto_merge/merge_train_service_spec.rb'
    - 'ee/spec/services/deployments/auto_rollback_service_spec.rb'
    - 'ee/spec/services/geo/design_repository_sync_service_spec.rb'
    - 'ee/spec/services/geo/files_expire_service_spec.rb'
    - 'ee/spec/services/geo/framework_repository_sync_service_spec.rb'
    - 'ee/spec/services/geo/job_artifact_deleted_event_store_spec.rb'
    - 'ee/spec/services/geo/project_housekeeping_service_spec.rb'
    - 'ee/spec/services/geo/repository_base_sync_service_spec.rb'
    - 'ee/spec/services/geo/repository_updated_service_spec.rb'
    - 'ee/spec/services/geo/repository_verification_primary_service_spec.rb'
    - 'ee/spec/services/groups/destroy_service_spec.rb'
    - 'ee/spec/services/ide/schemas_config_service_spec.rb'
    - 'ee/spec/services/merge_requests/build_service_spec.rb'
    - 'ee/spec/services/merge_trains/create_pipeline_service_spec.rb'
    - 'ee/spec/services/merge_trains/refresh_merge_request_service_spec.rb'
    - 'ee/spec/services/network_policies/resources_service_spec.rb'
    - 'ee/spec/services/projects/hashed_storage/migrate_repository_service_spec.rb'
    - 'ee/spec/services/security/token_revocation_service_spec.rb'
    - 'ee/spec/services/system_notes/merge_train_service_spec.rb'
    - 'ee/spec/services/wiki_pages/create_service_spec.rb'
    - 'ee/spec/services/wiki_pages/destroy_service_spec.rb'
    - 'ee/spec/services/wiki_pages/update_service_spec.rb'
    - 'ee/spec/support/shared_examples/models/concerns/elastic/cannot_read_cross_project_shared_examples.rb'
    - 'ee/spec/support/shared_examples/services/base_sync_service_shared_examples.rb'
    - 'ee/spec/support/shared_examples/services/geo_event_store_shared_examples.rb'
    - 'ee/spec/support/shared_examples/services/merge_merge_requests_shared_examples.rb'
    - 'ee/spec/views/admin/application_settings/_elasticsearch_form.html.haml_spec.rb'
    - 'ee/spec/views/admin/groups/_form.html.haml_spec.rb'
    - 'ee/spec/views/layouts/application.html.haml_spec.rb'
    - 'ee/spec/views/shared/_mirror_update_button.html.haml_spec.rb'
    - 'ee/spec/workers/ee/ci/build_finished_worker_spec.rb'
    - 'ee/spec/workers/geo/container_repository_sync_dispatch_worker_spec.rb'
    - 'ee/spec/workers/geo/design_repository_shard_sync_worker_spec.rb'
    - 'ee/spec/workers/geo/file_download_dispatch_worker_spec.rb'
    - 'ee/spec/workers/geo/repository_shard_sync_worker_spec.rb'
    - 'ee/spec/workers/geo/repository_verification/primary/shard_worker_spec.rb'
    - 'ee/spec/workers/geo/repository_verification/primary/single_worker_spec.rb'
    - 'ee/spec/workers/geo/repository_verification/secondary/shard_worker_spec.rb'
    - 'ee/spec/workers/geo/repository_verification/secondary/single_worker_spec.rb'
    - 'ee/spec/workers/post_receive_spec.rb'
    - 'ee/spec/workers/store_security_reports_worker_spec.rb'
    - 'ee/spec/workers/update_max_seats_used_for_gitlab_com_subscriptions_worker_spec.rb'
    - 'qa/spec/specs/runner_spec.rb'
    - 'spec/benchmarks/banzai_benchmark.rb'
    - 'spec/bin/feature_flag_spec.rb'
    - 'spec/config/settings_spec.rb'
    - 'spec/controllers/admin/application_settings_controller_spec.rb'
    - 'spec/controllers/admin/integrations_controller_spec.rb'
    - 'spec/controllers/concerns/page_limiter_spec.rb'
    - 'spec/controllers/concerns/send_file_upload_spec.rb'
    - 'spec/controllers/concerns/spammable_actions/akismet_mark_as_spam_action_spec.rb'
    - 'spec/controllers/concerns/spammable_actions/captcha_check/html_format_actions_support_spec.rb'
    - 'spec/controllers/concerns/spammable_actions/captcha_check/json_format_actions_support_spec.rb'
    - 'spec/controllers/concerns/spammable_actions/captcha_check/rest_api_actions_support_spec.rb'
    - 'spec/controllers/groups_controller_spec.rb'
    - 'spec/controllers/projects/environments_controller_spec.rb'
    - 'spec/controllers/projects/issues_controller_spec.rb'
    - 'spec/controllers/projects/jobs_controller_spec.rb'
    - 'spec/controllers/projects/merge_requests/creations_controller_spec.rb'
    - 'spec/controllers/projects/merge_requests_controller_spec.rb'
    - 'spec/controllers/projects/service_desk_controller_spec.rb'
    - 'spec/controllers/projects_controller_spec.rb'
    - 'spec/controllers/search_controller_spec.rb'
    - 'spec/features/groups/clusters/user_spec.rb'
    - 'spec/features/groups/container_registry_spec.rb'
    - 'spec/features/markdown/markdown_spec.rb'
    - 'spec/features/projects/clusters/gcp_spec.rb'
    - 'spec/features/projects/clusters/user_spec.rb'
    - 'spec/features/projects/container_registry_spec.rb'
    - 'spec/features/projects/environments/environment_spec.rb'
    - 'spec/features/projects/pages/user_edits_lets_encrypt_settings_spec.rb'
    - 'spec/features/projects/settings/service_desk_setting_spec.rb'
    - 'spec/finders/events_finder_spec.rb'
    - 'spec/finders/projects/groups_finder_spec.rb'
    - 'spec/finders/snippets_finder_spec.rb'
    - 'spec/finders/user_recent_events_finder_spec.rb'
    - 'spec/graphql/mutations/environments/canary_ingress/update_spec.rb'
    - 'spec/graphql/types/project_type_spec.rb'
    - 'spec/helpers/auth_helper_spec.rb'
    - 'spec/helpers/broadcast_messages_helper_spec.rb'
    - 'spec/helpers/dashboard_helper_spec.rb'
    - 'spec/helpers/diff_helper_spec.rb'
    - 'spec/helpers/explore_helper_spec.rb'
    - 'spec/helpers/groups_helper_spec.rb'
    - 'spec/helpers/issues_helper_spec.rb'
    - 'spec/helpers/nav/new_dropdown_helper_spec.rb'
    - 'spec/helpers/nav/top_nav_helper_spec.rb'
    - 'spec/helpers/nav_helper_spec.rb'
    - 'spec/helpers/operations_helper_spec.rb'
    - 'spec/helpers/projects_helper_spec.rb'
    - 'spec/helpers/users/callouts_helper_spec.rb'
    - 'spec/helpers/users_helper_spec.rb'
    - 'spec/helpers/visibility_level_helper_spec.rb'
    - 'spec/lib/backup/files_spec.rb'
    - 'spec/lib/banzai/filter/issuable_reference_expansion_filter_spec.rb'
    - 'spec/lib/banzai/filter/references/external_issue_reference_filter_spec.rb'
    - 'spec/lib/banzai/reference_parser/issue_parser_spec.rb'
    - 'spec/lib/banzai/reference_redactor_spec.rb'
    - 'spec/lib/file_size_validator_spec.rb'
    - 'spec/lib/gitlab/auth/o_auth/user_spec.rb'
    - 'spec/lib/gitlab/auth/saml/user_spec.rb'
    - 'spec/lib/gitlab/auth_spec.rb'
    - 'spec/lib/gitlab/background_migration/encrypt_static_object_token_spec.rb'
    - 'spec/lib/gitlab/batch_pop_queueing_spec.rb'
    - 'spec/lib/gitlab/bitbucket_import/importer_spec.rb'
    - 'spec/lib/gitlab/ci/build/policy/changes_spec.rb'
    - 'spec/lib/gitlab/ci/config/external/mapper_spec.rb'
    - 'spec/lib/gitlab/ci/config/external/processor_spec.rb'
    - 'spec/lib/gitlab/ci/pipeline/seed/stage_spec.rb'
    - 'spec/lib/gitlab/ci/status/build/failed_spec.rb'
    - 'spec/lib/gitlab/ci/trace/remote_checksum_spec.rb'
    - 'spec/lib/gitlab/contributions_calendar_spec.rb'
    - 'spec/lib/gitlab/daemon_spec.rb'
    - 'spec/lib/gitlab/database_importers/instance_administrators/create_group_spec.rb'
    - 'spec/lib/gitlab/diff/file_spec.rb'
    - 'spec/lib/gitlab/email/message/build_ios_app_guide_spec.rb'
    - 'spec/lib/gitlab/email/message/in_product_marketing/helper_spec.rb'
    - 'spec/lib/gitlab/error_tracking_spec.rb'
    - 'spec/lib/gitlab/exclusive_lease_helpers/sleeping_lock_spec.rb'
    - 'spec/lib/gitlab/exclusive_lease_helpers_spec.rb'
    - 'spec/lib/gitlab/experimentation/controller_concern_spec.rb'
    - 'spec/lib/gitlab/external_authorization_spec.rb'
    - 'spec/lib/gitlab/git/blob_spec.rb'
    - 'spec/lib/gitlab/git_access_spec.rb'
    - 'spec/lib/gitlab/git_access_wiki_spec.rb'
    - 'spec/lib/gitlab/gitaly_client/call_spec.rb'
    - 'spec/lib/gitlab/health_checks/puma_check_spec.rb'
    - 'spec/lib/gitlab/import_export/config_spec.rb'
    - 'spec/lib/gitlab/instrumentation/redis_base_spec.rb'
    - 'spec/lib/gitlab/legacy_github_import/importer_spec.rb'
    - 'spec/lib/gitlab/memory/instrumentation_spec.rb'
    - 'spec/lib/gitlab/metrics/rails_slis_spec.rb'
    - 'spec/lib/gitlab/metrics/system_spec.rb'
    - 'spec/lib/gitlab/middleware/read_only_spec.rb'
    - 'spec/lib/gitlab/pagination/gitaly_keyset_pager_spec.rb'
    - 'spec/lib/gitlab/prometheus_client_spec.rb'
    - 'spec/lib/gitlab/redis/cache_spec.rb'
    - 'spec/lib/gitlab/redis/shared_state_spec.rb'
    - 'spec/lib/gitlab/relative_positioning/range_spec.rb'
    - 'spec/lib/gitlab/sidekiq_daemon/memory_killer_spec.rb'
    - 'spec/lib/gitlab/sidekiq_logging/structured_logger_spec.rb'
    - 'spec/lib/gitlab/sidekiq_middleware/duplicate_jobs/duplicate_job_spec.rb'
    - 'spec/lib/gitlab/sidekiq_middleware/duplicate_jobs/strategies/until_executed_spec.rb'
    - 'spec/lib/gitlab/workhorse_spec.rb'
    - 'spec/lib/safe_zip/entry_spec.rb'
    - 'spec/lib/system_check/simple_executor_spec.rb'
    - 'spec/models/ability_spec.rb'
    - 'spec/models/blob_spec.rb'
    - 'spec/models/ci/build_spec.rb'
    - 'spec/models/ci/pipeline_spec.rb'
    - 'spec/models/ci/processable_spec.rb'
    - 'spec/models/concerns/deprecated_assignee_spec.rb'
    - 'spec/models/concerns/discussion_on_diff_spec.rb'
    - 'spec/models/diff_note_spec.rb'
    - 'spec/models/diff_viewer/image_spec.rb'
    - 'spec/models/environment_spec.rb'
    - 'spec/models/integrations/jira_spec.rb'
    - 'spec/models/internal_id_spec.rb'
    - 'spec/models/issue_spec.rb'
    - 'spec/models/merge_request_spec.rb'
    - 'spec/models/pages_domain_spec.rb'
    - 'spec/models/project_spec.rb'
    - 'spec/models/project_statistics_spec.rb'
    - 'spec/models/snippet_statistics_spec.rb'
    - 'spec/models/user_spec.rb'
    - 'spec/models/wiki_page_spec.rb'
    - 'spec/policies/issue_policy_spec.rb'
    - 'spec/presenters/ci/pipeline_presenter_spec.rb'
    - 'spec/presenters/commit_status_presenter_spec.rb'
    - 'spec/presenters/merge_request_presenter_spec.rb'
    - 'spec/requests/api/ci/jobs_spec.rb'
    - 'spec/requests/api/graphql/read_only_spec.rb'
    - 'spec/requests/api/groups_spec.rb'
    - 'spec/requests/api/internal/base_spec.rb'
    - 'spec/requests/api/merge_requests_spec.rb'
    - 'spec/requests/api/project_container_repositories_spec.rb'
    - 'spec/requests/git_http_spec.rb'
    - 'spec/requests/health_controller_spec.rb'
    - 'spec/requests/lfs_http_spec.rb'
    - 'spec/requests/users_controller_spec.rb'
    - 'spec/serializers/diff_file_entity_spec.rb'
    - 'spec/serializers/merge_request_poll_cached_widget_entity_spec.rb'
    - 'spec/services/application_settings/update_service_spec.rb'
    - 'spec/services/auto_merge/base_service_spec.rb'
    - 'spec/services/auto_merge/merge_when_pipeline_succeeds_service_spec.rb'
    - 'spec/services/captcha/captcha_verification_service_spec.rb'
    - 'spec/services/ci/archive_trace_service_spec.rb'
    - 'spec/services/ci/create_pipeline_service/logger_spec.rb'
    - 'spec/services/ci/list_config_variables_service_spec.rb'
    - 'spec/services/ci/pipeline_artifacts/destroy_all_expired_service_spec.rb'
    - 'spec/services/ci/pipeline_trigger_service_spec.rb'
    - 'spec/services/ci/process_build_service_spec.rb'
    - 'spec/services/ci/register_job_service_spec.rb'
    - 'spec/services/ci/resource_groups/assign_resource_from_resource_group_service_spec.rb'
    - 'spec/services/environments/auto_stop_service_spec.rb'
    - 'spec/services/environments/canary_ingress/update_service_spec.rb'
    - 'spec/services/environments/reset_auto_stop_service_spec.rb'
    - 'spec/services/git/branch_hooks_service_spec.rb'
    - 'spec/services/git/branch_push_service_spec.rb'
    - 'spec/services/git/process_ref_changes_service_spec.rb'
    - 'spec/services/groups/create_service_spec.rb'
    - 'spec/services/groups/nested_create_service_spec.rb'
    - 'spec/services/merge_requests/merge_orchestration_service_spec.rb'
    - 'spec/services/merge_requests/merge_service_spec.rb'
    - 'spec/services/merge_requests/merge_to_ref_service_spec.rb'
    - 'spec/services/merge_requests/mergeability_check_service_spec.rb'
    - 'spec/services/merge_requests/update_service_spec.rb'
    - 'spec/services/notes/create_service_spec.rb'
    - 'spec/services/notes/destroy_service_spec.rb'
    - 'spec/services/notification_service_spec.rb'
    - 'spec/services/projects/after_rename_service_spec.rb'
    - 'spec/services/projects/apple_target_platform_detector_service_spec.rb'
    - 'spec/services/projects/create_service_spec.rb'
    - 'spec/services/projects/hashed_storage/migrate_attachments_service_spec.rb'
    - 'spec/services/projects/hashed_storage/migrate_repository_service_spec.rb'
    - 'spec/services/projects/hashed_storage/rollback_attachments_service_spec.rb'
    - 'spec/services/projects/hashed_storage/rollback_repository_service_spec.rb'
    - 'spec/services/projects/in_product_marketing_campaign_emails_service_spec.rb'
    - 'spec/services/projects/update_remote_mirror_service_spec.rb'
    - 'spec/services/projects/update_service_spec.rb'
    - 'spec/services/suggestions/apply_service_spec.rb'
    - 'spec/services/suggestions/create_service_spec.rb'
    - 'spec/services/verify_pages_domain_service_spec.rb'
    - 'spec/support/redis/redis_shared_examples.rb'
    - 'spec/support/shared_contexts/services/projects/container_repository/delete_tags_service_shared_context.rb'
    - 'spec/support/shared_examples/features/container_registry_shared_examples.rb'
    - 'spec/support/shared_examples/finders/snippet_visibility_shared_examples.rb'
    - 'spec/support/shared_examples/lib/gitlab/middleware/read_only_gitlab_instance_shared_examples.rb'
    - 'spec/support/shared_examples/lib/gitlab/sidekiq_middleware/strategy_shared_examples.rb'
    - 'spec/support/shared_examples/models/concerns/can_move_repository_storage_shared_examples.rb'
    - 'spec/support/shared_examples/models/wiki_shared_examples.rb'
    - 'spec/support/shared_examples/path_extraction_shared_examples.rb'
    - 'spec/support/shared_examples/requests/api/conan_packages_shared_examples.rb'
    - 'spec/support/shared_examples/services/boards/boards_create_service_shared_examples.rb'
    - 'spec/support/shared_examples/services/boards/create_service_shared_examples.rb'
    - 'spec/support/shared_examples/uploaders/object_storage_shared_examples.rb'
    - 'spec/support/shared_examples/workers/concerns/git_garbage_collect_methods_shared_examples.rb'
    - 'spec/uploaders/file_mover_spec.rb'
    - 'spec/uploaders/gitlab_uploader_spec.rb'
    - 'spec/uploaders/object_storage_spec.rb'
    - 'spec/uploaders/workers/object_storage/background_move_worker_spec.rb'
    - 'spec/views/admin/application_settings/_ci_cd.html.haml_spec.rb'
    - 'spec/views/admin/application_settings/_eks.html.haml_spec.rb'
    - 'spec/views/admin/application_settings/_package_registry.html.haml_spec.rb'
    - 'spec/views/projects/settings/ci_cd/_autodevops_form.html.haml_spec.rb'
    - 'spec/views/shared/milestones/_top.html.haml_spec.rb'
    - 'spec/views/shared/projects/_project.html.haml_spec.rb'
    - 'spec/views/shared/snippets/_snippet.html.haml_spec.rb'
    - 'spec/workers/environments/auto_delete_cron_worker_spec.rb'
    - 'spec/workers/projects/git_garbage_collect_worker_spec.rb'
